/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef SCOUT_PATTERNS_GEN_H
#define SCOUT_PATTERNS_GEN_H


namespace scout
{

//--- Constants -------------------------------------------------------------

const long PAT_NONE                           =  -1;
const long PAT_TIME                           =   0;
const long PAT_VISITS                         =   1;
const long PAT_EXECUTION                      =   2;
const long PAT_OVERHEAD                       =   3;
const long PAT_ASYNC                          =   4;
const long PAT_MPI                            =   5;
const long PAT_MPI_SYNCHRONIZATION            =   6;
const long PAT_MPI_COMMUNICATION              =   7;
const long PAT_MPI_IO                         =   8;
const long PAT_MPI_IO_COLLECTIVE              =   9;
const long PAT_MPI_INIT_EXIT                  =  10;
const long PAT_MPI_FINALIZE_WAIT              =  11;
const long PAT_MPI_INIT_COMPLETION            =  12;
const long PAT_MPI_SYNC_COLLECTIVE            =  13;
const long PAT_MPI_BARRIER_WAIT               =  14;
const long PAT_MPI_BARRIER_COMPLETION         =  15;
const long PAT_MPI_POINT2POINT                =  16;
const long PAT_MPI_LATESENDER                 =  17;
const long PAT_MPI_LATESENDER_WO              =  18;
const long PAT_MPI_LSWO_DIFFERENT             =  19;
const long PAT_MPI_LSWO_SAME                  =  20;
const long PAT_MPI_LATERECEIVER               =  21;
const long PAT_MPI_COLLECTIVE                 =  22;
const long PAT_MPI_EARLYREDUCE                =  23;
const long PAT_MPI_EARLYSCAN                  =  24;
const long PAT_MPI_LATEBROADCAST              =  25;
const long PAT_MPI_WAIT_NXN                   =  26;
const long PAT_MPI_NXN_COMPLETION             =  27;
const long PAT_OMP_IDLE_THREADS               =  28;
const long PAT_OMP_LIMITED_PARALLELISM        =  29;
const long PAT_OMP_TIME                       =  30;
const long PAT_OMP_FLUSH                      =  31;
const long PAT_OMP_MANAGEMENT                 =  32;
const long PAT_OMP_FORK                       =  33;
const long PAT_OMP_SYNCHRONIZATION            =  34;
const long PAT_OMP_BARRIER                    =  35;
const long PAT_OMP_EBARRIER                   =  36;
const long PAT_OMP_EBARRIER_WAIT              =  37;
const long PAT_OMP_IBARRIER                   =  38;
const long PAT_OMP_IBARRIER_WAIT              =  39;
const long PAT_OMP_CRITICAL                   =  40;
const long PAT_OMP_LOCK_API                   =  41;
const long PAT_OMP_ORDERED                    =  42;
const long PAT_SYNCS                          =  43;
const long PAT_SYNCS_P2P                      =  44;
const long PAT_SYNCS_SEND                     =  45;
const long PAT_SYNCS_RECV                     =  46;
const long PAT_SYNCS_COLL                     =  47;
const long PAT_COMMS                          =  48;
const long PAT_COMMS_P2P                      =  49;
const long PAT_COMMS_SEND                     =  50;
const long PAT_COMMS_RECV                     =  51;
const long PAT_COMMS_COLL                     =  52;
const long PAT_COMMS_CXCH                     =  53;
const long PAT_COMMS_CSRC                     =  54;
const long PAT_COMMS_CDST                     =  55;
const long PAT_BYTES                          =  56;
const long PAT_BYTES_P2P                      =  57;
const long PAT_BYTES_SENT                     =  58;
const long PAT_BYTES_RCVD                     =  59;
const long PAT_BYTES_COLL                     =  60;
const long PAT_BYTES_COUT                     =  61;
const long PAT_BYTES_CIN                      =  62;
const long PAT_BYTES_RMA                      =  63;
const long PAT_BYTES_GET                      =  64;
const long PAT_BYTES_PUT                      =  65;
const long PAT_MPI_CLS_COUNT                  =  66;
const long PAT_MPI_CLSWO_COUNT                =  67;
const long PAT_MPI_CLR_COUNT                  =  68;
const long PAT_MPI_SLS_COUNT                  =  69;
const long PAT_MPI_SLSWO_COUNT                =  70;
const long PAT_MPI_SLR_COUNT                  =  71;
const long PAT_MPI_FILE_OPS                   =  72;
const long PAT_MPI_FILE_IOPS                  =  73;
const long PAT_MPI_FILE_IROPS                 =  74;
const long PAT_MPI_FILE_IWOPS                 =  75;
const long PAT_MPI_FILE_COPS                  =  76;
const long PAT_MPI_FILE_CROPS                 =  77;
const long PAT_MPI_FILE_CWOPS                 =  78;
const long PAT_MPI_FILE_BYTES                 =  79;
const long PAT_MPI_FILE_IBYTES                =  80;
const long PAT_MPI_FILE_IRBYTES               =  81;
const long PAT_MPI_FILE_IWBYTES               =  82;
const long PAT_MPI_FILE_CBYTES                =  83;
const long PAT_MPI_FILE_CRBYTES               =  84;
const long PAT_MPI_FILE_CWBYTES               =  85;
const long PAT_MPI_RMA_SYNCHRONIZATION        =  86;
const long PAT_MPI_RMA_COMMUNICATION          =  87;
const long PAT_MPI_RMA_SYNC_LATE_POST         =  88;
const long PAT_MPI_RMA_COMM_LATE_POST         =  89;
const long PAT_MPI_RMA_EARLY_WAIT             =  90;
const long PAT_MPI_RMA_LATE_COMPLETE          =  91;
const long PAT_MPI_RMA_WAIT_AT_CREATE         =  92;
const long PAT_MPI_RMA_WAIT_AT_FREE           =  93;
const long PAT_MPI_RMA_WAIT_AT_FENCE          =  94;
const long PAT_MPI_RMA_EARLY_FENCE            =  95;
const long PAT_MPI_RMA_PAIRSYNC_COUNT         =  96;
const long PAT_MPI_RMA_PAIRSYNC_UNNEEDED_COUNT =  97;
const long PAT_MPI_RMA_SYNC_LOCK_COMPETITION  =  98;
const long PAT_MPI_RMA_COMM_LOCK_COMPETITION  =  99;
const long PAT_MPI_RMA_COMM_WAIT_FOR_PROGRESS = 100;
const long PAT_MPI_RMA_SYNC_WAIT_FOR_PROGRESS = 101;
const long PAT_IMBALANCE                      = 102;
const long PAT_IMBALANCE_ABOVE                = 103;
const long PAT_IMBALANCE_ABOVE_SINGLE         = 104;
const long PAT_IMBALANCE_BELOW                = 105;
const long PAT_IMBALANCE_BELOW_BYPASS         = 106;
const long PAT_IMBALANCE_BELOW_SINGULARITY    = 107;
const long PAT_STATISTICS                     = 108;
const long PAT_CRITICAL_PATH                  = 109;
const long PAT_CRITICAL_PATH_IMBALANCE        = 110;


//--- Forward declarations --------------------------------------------------

class AnalyzeTask;


//--- Function prototypes ---------------------------------------------------

void create_patterns(AnalyzeTask* analyzer);


}   /* namespace scout */


#endif   /* !SCOUT_PATTERNS_GEN_H */
